-- Woody
-- by Hansi-TWZ
-- DE333-SERVER.EU
-- Credits to MewMew (Comfy)

local table_insert = table.insert
local math_random = math.random

local tile_replacements = {
	["dirt-7"] = "grass-1",
	["dirt-6"] = "grass-2",
	["dirt-5"] = "grass-3",
	["dirt-4"] = "grass-4",
	["dirt-3"] = "grass-1",
	["dirt-2"] = "grass-2",
	["dirt-1"] = "grass-3",
	["sand-1"] = "grass-4",
	["sand-2"] = "grass-1",
	["sand-3"] = "grass-2",
	["red-desert-1"] = "grass-3",
	["red-desert-2"] = "grass-4",
	["red-desert-3"] = "grass-1",
	["red-desert-0"] = "grass-2",
	["dry-dirt"] = "grass-3"
}

-- local entity_replacements = {
	-- ["tree-01"] = "dead-grey-trunk",
	-- ["tree-02"] = "tree-06-brown",
	-- ["tree-03"] = "dead-grey-trunk",
	-- ["tree-04"] = "dry-hairy-tree",	
	-- ["tree-05"] = "dead-grey-trunk",	
	-- ["tree-06"] = "tree-06-brown",	
	-- ["tree-07"] = "dry-hairy-tree",	
	-- ["tree-08"] = "dead-grey-trunk",	
	-- ["tree-09"] = "tree-06-brown",
	-- ["tree-02-red"] = "dry-tree",	
	-- ["tree-08-brown"] = "tree-06-brown",	
	-- ["tree-09-brown"] = "tree-06-brown",	
	-- ["tree-09-red"] = "tree-06-brown"
-- }

local entity_replacements = {
	["dead-grey-trunk"] = "tree-09-red",
	["tree-06-brown"] = "tree-09-red",
	["dry-hairy-tree"] = "dead-grey-trunk",
	["dry-tree"] = "tree-08-brown"
}

local function process_entity(e)
	if not e.valid then return end
	if entity_replacements[e.name] then		
		if e.type == "tree" then
			if math_random(1,2) == 1 then
				e.surface.create_entity({name = entity_replacements[e.name], position = e.position})
			end
		else
			e.surface.create_entity({name = entity_replacements[e.name], position = e.position})
		end
		e.destroy()
		return
	end
end

function Woody(event)
	local surface = event.surface
	local left_top = event.area.left_top
	local tiles = {}
	local entities = {}		
	
	for x = 0, 31, 1 do
		for y = 0, 31, 1 do
			local tile_to_insert = false
			local pos = {x = left_top.x + x, y = left_top.y + y}
											
			local tile = surface.get_tile(pos)
			if tile_replacements[tile.name] then
				table_insert(tiles, {name = tile_replacements[tile.name], position = pos})
			end
		end
	end
	surface.set_tiles(tiles, true)
	for _, e in pairs(surface.find_entities_filtered({area = event.area})) do
		process_entity(e)		
	end
end