-- tag.lua
-- Apr 2017
-- Allows adding play tags

function CreateTagGui(event)
    local player = game.players[event.player_index]
    if player.gui.top.tag == nil then
        player.gui.top.add{name="tag", type="button", caption="Tag"}
    end   
end

-- Tag list
local roles = {
  {display_name = "[img=entity.character][color=1,1,1][Solo][/color]"},
  {display_name = "[img=item.dummy-steel-axe][color=1,1,1][Mining][/color]"},
  {display_name = "[img=item.battery][color=1,1,1][Power][/color]"},
  {display_name = "[img=fluid.crude-oil][color=1,1,1][Oil][/color]"},
  {display_name = "[img=item.stone-furnace][color=1,1,1][Smelt][/color]"},
  {display_name = "[img=item.rail][color=1,1,1][Rail][/color]"},
  {display_name = "[img=item.gun-turret][color=1,1,1][Defense][/color]"},
  {display_name = "[img=item.electronic-circuit][color=1,1,1][Circuits][/color]"},
  {display_name = "[img=item.automation-science-pack][color=1,1,1][Science!][/color]"},
  {display_name = "[img=item.transport-belt][color=1,1,1][Logistics][/color]"},
  {display_name = "[img=entity.behemoth-spitter][color=1,1,1][Aliens][/color]"},
  {display_name = "[img=item.satellite][color=1,1,1][Rocket][/color]"},
  {display_name = "[img=technology.belt-immunity-equipment][color=1,1,1][AFK][/color]"}}

local function ExpandTagGui(player)
    local frame = player.gui.left["tag-panel"]
    if (frame) then
        frame.destroy()
    else
        local frame = player.gui.left.add{type="frame", name="tag-panel", caption="What are you doing:", direction = "vertical"}
        for _, role in pairs(roles) do
            frame.add{type="button", caption=role.display_name, name=role.display_name}
        end
        if (player.admin) then
            frame.add{type="button", caption="[img=technology/atomic-bomb][color=1,1,1][Admin][/color]", name="admin"}
            frame.add{type="button", caption="[img=technology/atomic-bomb][color=1,1,1][Moderator][/color]", name="moderator"}
            frame.add{type="button", caption="Clear", name="clear_btn"}
        end
    end
end

function TagGuiClick(event) 
    if not (event and event.element and event.element.valid) then return end
    local player = game.players[event.element.player_index]
    local name = event.element.name

    if (name == "tag") then
        ExpandTagGui(player)        
    end
    
    if (name == "clear_btn") then 
        player.tag = ""
        return
    end
    
    for _, role in pairs(roles) do
        if (name == role.display_name) then
            player.tag = role.display_name
        elseif (name == "admin") then
            player.tag = "[img=technology/atomic-bomb][color=1,1,1][Admin][/color]"
        elseif (name == "moderator") then
            player.tag = "[img=technology/atomic-bomb][color=1,1,1][Moderator][/color]"
        end
    end
end
